package examples.dao.backport175;


import java.util.List;

/**
 * 
 * @author ㌴@cO
 * @org.seasar.dao.annotation.backport175.S2Dao(bean=examples.dao.backport175.Employee.class)
 */
public interface EmployeeAutoDao {

	public List getAllEmployees();

	/**
	 * @org.seasar.dao.annotation.backport175.Arguments (
	 * 	{"job","deptno"}
	 * )
	 */
	public List getEmployeeByJobDeptno(String job, Integer deptno);
	
	/**
	 * @org.seasar.dao.annotation.backport175.Arguments (
	 * 	{"empno"}
	 * )
	 */
	public Employee getEmployeeByEmpno(int empno);

	/**
	 * @org.seasar.dao.annotation.backport175.Query (
	 * 	"sal BETWEEN ? AND ? ORDER BY empno"
	 * )
	 */
	public List getEmployeesBySal(float minSal, float maxSal);

	/**
	 * @org.seasar.dao.annotation.backport175.Arguments (
	 * 	{"dname_0"}
	 * )
	 */
	public List getEmployeeByDname(String dname);
	
	public List getEmployeesBySearchCondition(EmployeeSearchCondition dto);
	
	public void update(Employee employee);
}